/*******************************************************************************
  * @file    main.c 
  * @author  Nenad Jovicic
  * @version V1.0.0
  * @date    28/11/2012
  * @brief   Main program body.
*******************************************************************************/
// Includes 
#include "stm32f10x.h"
#include "misc.h"

//void LED_Delay(void);

//DEKLARACIJA STRUKTURA PERIFERIJA KOJE KORISTIMO
//Deklaracija strukture za GPIO periferiju
GPIO_InitTypeDef GPIO_InitStructure;
//Deklaracija strukture za vremensku bazu tajmera
TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
//Deklaracija strukture za NVIC
NVIC_InitTypeDef NVIC_InitStructure;


int main(void)
{
  
  //DOVODIMO KLOK SIGNAL PERIFERIJAMA KOJE KORISTIMO
  //Dovodimo klok signal GPIOC periferiji
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
  //Dovodimo klok signal TIMER2 periferiji
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
  
  
  //INICIJALIZACIJA GPIOC PERIFERIJE
  //Konfiguracija strukture za pinove PC.08 i PC.09
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  //Inicijalizacija pinova za GPIOC periferiju
  GPIO_Init(GPIOC, &GPIO_InitStructure);
  
  //INICIJALIZACIJA TIMER2 PERIFERIJE
  //Konfiguracija strukture za TIMER2 periferiju
  TIM_TimeBaseStructure.TIM_Period = 5400;
  TIM_TimeBaseStructure.TIM_Prescaler = 8880;
  TIM_TimeBaseStructure.TIM_ClockDivision = 0;
  TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
  //Inicijalizacija TIMER2 periferije
  TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
 
  
  //DOZVOLA GENERISANJA PREKIDA
  //Dozvola generisanja prekida od strane TIM2 periferije
  NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  //Inicijalizacija NVIC periferije
  NVIC_Init(&NVIC_InitStructure);
  
  //Dozvola generisanja prekida na nivou periferije
  TIM_ITConfig(TIM2,TIM_IT_Update, ENABLE);
  
  //Startovanje TIMER2 periferije
  TIM_Cmd(TIM2, ENABLE);
  
  while (1)
  {}
  
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */

/**
  * @}
  */

/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/
