#include "stm32F10x.h"
#include "STM32vldiscovery.h"

  //Deklaracija struktura za razne periferije
  GPIO_InitTypeDef GPIO_InitStructure;
  TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct;
  TIM_OCInitTypeDef TIM_OCInitStruct;
  NVIC_InitTypeDef NVIC_InitStructure;  
  EXTI_InitTypeDef EXTI_InitStructure;
 
    volatile int i;
    int n = 1;
    int brightness = 0;
 
int main(void)
{
  
    //Dovodimo klok signal periferijama
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOC | RCC_APB2Periph_AFIO, ENABLE ); 
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM3, ENABLE );
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
 
    //inicijalizacija portova
    GPIO_StructInit(&GPIO_InitStructure); // Reset init structure 
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_8;//plava LED dioda
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;            // konfiguracija za alternativnu funkciju - Push Pull
    //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // ovo bi bila konfiguracija da se koristi kao obican pin
    GPIO_Init( GPIOC, &GPIO_InitStructure );
    GPIO_PinRemapConfig( GPIO_FullRemap_TIM3, ENABLE );        // Map TIM3_CH3 to GPIOC.Pin8, TIM3_CH4 to GPIOC.Pin9
 
    GPIO_StructInit(&GPIO_InitStructure); // Reset init structure 
    // Setup Blue & Green LED on STM32-Discovery Board to use PWM.
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_9;//zelena LED dioda
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;            // konfiguracija za alternativnu funkciju - Push Pull
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;            // ovo bi bila konfiguracija da se koristi kao obican pin
    GPIO_Init( GPIOC, &GPIO_InitStructure );

    //Tajmer TI3 radi u modu generisanja PWM signala

    //Inicijalizacija vremenske baze tajmera TIM3
    // Let PWM frequency equal 100Hz.
    // Let period equal 1000. Therefore, timer runs from zero to 1000. Gives 0.1Hz resolution.
    // Solving for prescaler gives 240.
    TIM_TimeBaseStructInit( &TIM_TimeBaseInitStruct );
    TIM_TimeBaseInitStruct.TIM_ClockDivision = TIM_CKD_DIV4;
    TIM_TimeBaseInitStruct.TIM_Period = 1000 - 1;   // 0..999
    TIM_TimeBaseInitStruct.TIM_Prescaler = 240 - 1; // Div 240
    TIM_TimeBaseInit( TIM3, &TIM_TimeBaseInitStruct );
 
    //Inicijalizacija OC strukture tajmera TIM3
    TIM_OCStructInit( &TIM_OCInitStruct );
    TIM_OCInitStruct.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStruct.TIM_OCMode = TIM_OCMode_PWM1;
    //Initial duty cycle equals 0%. Value can range from zero to 1000.
    TIM_OCInitStruct.TIM_Pulse = 0; // 0 .. 1000 (0=Always Off, 1000=Always On) 
    TIM_OC3Init( TIM3, &TIM_OCInitStruct ); // Channel 3 Blue LED
    TIM_Cmd( TIM3, ENABLE );//startovanje tajmera
    
    //INICIJALIZACIJA TIMER2 PERIFERIJE KOJA CE DA GENERISE PERIODICNI PREKID
    //Konfiguracija vremenske baze za TIMER2 periferiju
    TIM_TimeBaseInitStruct.TIM_Period = 5400;
    TIM_TimeBaseInitStruct.TIM_Prescaler = 8880;
    TIM_TimeBaseInitStruct.TIM_ClockDivision = 0;
    TIM_TimeBaseInitStruct.TIM_CounterMode = TIM_CounterMode_Up;
    //Inicijalizacija TIMER2 periferije
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStruct);
    //Dozvola generisanja prekida na nivou periferije
    TIM_ITConfig(TIM2,TIM_IT_Update, ENABLE);
    //Startovanje TIMER2 periferije
    TIM_Cmd(TIM2, ENABLE);
       
    ////EXTI/////
    //POVEZIVANJE GPIO PINA NA ODREDJENU EXTI LINIJU
    GPIO_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource0);//KORISNICKO DUGME SE NAPALA NA PINU PA0

    //KONFIGURACIJA EXTI KONTROLERA ZA EXTI0 LINIJU
    EXTI_InitStructure.EXTI_Line = EXTI_Line0;
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising; 
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;
    EXTI_Init(&EXTI_InitStructure);
    
    //DOZVOLA GENERISANJA PREKIDA
    //Dozvola generisanja prekida od strane TIM2 periferije
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    //Inicijalizacija NVIC periferije
    NVIC_Init(&NVIC_InitStructure);

    //DOZVOLA GENERISANJA PREKIDA  OD STRANE EXTI PERIFERIJE
    NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure); 
 
  while(1)  // Do not exit
  {
    if (((brightness + n) >= 1000) || ((brightness + n) <= 0))
      n = -n; // if  brightness maximum/maximum change direction
 
        brightness += n;
 
    TIM3->CCR3 = brightness; // set brightness
 
    for(i=0;i<2000;i++);  // delay
  }
}